package main

import (
	"github.com/andlabs/ui"
    _ "github.com/andlabs/ui/winmanifest"
)

var mainwin *ui.Window

func makeDataChoosersPage() ui.Control {
    hbox := ui.NewHorizontalBox()
    hbox.SetPadded(true)

    vbox := ui.NewVerticalBox()
    vbox.SetPadded(true)
    hbox.Append(vbox, true)

    grid := ui.NewGrid()
    grid.SetPadded(true)
    vbox.Append(grid, false)

    button := ui.NewButton("Message Box")
    button.OnClicked(func(*ui.Button) {
        ui.MsgBox(mainwin,
            "This is a normal message box.",
            "More detailed information can be shown here.")
    })
    grid.Append(button,
        0, 0, 1, 1,
        false, ui.AlignFill, false, ui.AlignFill)


    button = ui.NewButton("Message Box")
    button.OnClicked(func(*ui.Button) {
        ui.MsgBox(mainwin,
            "This is a normal message box.",
            "More detailed information can be shown here.")
    })
    grid.Append(button,
        1, 0, 1, 1,
        false, ui.AlignFill, false, ui.AlignFill)
        
    button = ui.NewButton("Error Box")
    button.OnClicked(func(*ui.Button) {
        ui.MsgBoxError(mainwin,
            "This message box describes an error.",
            "More detailed information can be shown here.")
    })
    grid.Append(button,
        2, 0, 1, 1,
        false, ui.AlignFill, false, ui.AlignFill)

    button = ui.NewButton("Exit")
    button.OnClicked(func(*ui.Button) {  mainwin.Destroy()  })
    grid.Append(button,
        3, 0, 1, 1,
        false, ui.AlignFill, false, ui.AlignFill)

    return hbox
}

func setupUI() {
	mainwin = ui.NewWindow("libui Control Gallery", 640, 480, true)
	mainwin.OnClosing(func(*ui.Window) bool {
		ui.Quit()
		return true
	})
	ui.OnShouldQuit(func() bool {
		mainwin.Destroy()
		return true
	})

	tab := ui.NewTab()
	mainwin.SetChild(tab)
	mainwin.SetMargined(true)

	tab.Append("Data Choosers", makeDataChoosersPage())
	tab.SetMargined(0, true)

	mainwin.Show()
}

func main() {
	ui.Main(setupUI)
}
